;;; Sierra Script 1.0 - (do not remove this comment)
(script# 68)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	Room68 0
)

(local
	newProp
	newAct
	local2
	local3
)
(instance Room68 of Rm
	(properties
		picture 68
		style $0010
		south 17
	)
	
	(method (init)
		(Load rsVIEW 533)
		(Load rsVIEW 536)
		(super init:)
		(self setRegions: 603)
		(if (== global134 4)
			(Load rsVIEW 206)
			(Load rsVIEW 204)
		)
		((View new:)
			view: 536
			loop: 7
			cel: 0
			posn: 77 109
			setPri: 8
			addToPic:
		)
		(= global105 0)
		(if global100
			((Prop new:)
				view: 536
				loop: 4
				posn: 79 98
				setPri: 11
				init:
				setCycle: Fwd
			)
		)
		(= global101 1)
		((= newProp (Prop new:))
			isExtra: 1
			view: 533
			loop: 0
			posn: 223 131
			init:
			setPri: 11
			cycleSpeed: 4
			setCycle: Fwd
		)
		(gEgo
			view: 4
			setLoop: -1
			setCycle: Walk
			illegalBits: -32768
			setStep: 4 2
		)
		(switch gPicture
			(67
				(gEgo
					posn: 56 165
					loop: 0
					init:
					baseSetter: (ScriptID 0 1)
				)
			)
			(64
				(gEgo
					posn: 262 167
					loop: 1
					init:
					baseSetter: (ScriptID 0 1)
				)
			)
			(62
				(gEgo posn: 97 79 loop: 2 init: baseSetter: 0)
			)
			(60
				(gEgo posn: 198 81 loop: 2 init: baseSetter: 0)
			)
			(17
				(gEgo
					posn: 153 182
					loop: 3
					init:
					baseSetter: (ScriptID 0 1)
				)
			)
		)
		((= newAct (Act new:))
			illegalBits: 0
			ignoreActors: 1
			setScript: mirrorTricks
		)
		(if
			(and
				(< 0 global134)
				(< global134 255)
				(== global133 gGNewPropX)
			)
			(proc0_10 603 -1)
		)
	)
	
	(method (doit)
		(if (& (= local2 (gEgo onControl: 0)) $0040)
			(gEgo loop: 2 baseSetter: 0)
			(proc0_18)
			(global2 newRoom: 17)
		)
		(if (& local2 $0020)
			(gEgo loop: 1 baseSetter: 0)
			(proc0_18)
			(global2 newRoom: 67)
		)
		(if (& local2 $0010)
			(gEgo loop: 3 baseSetter: 0)
			(proc0_18)
			(global2 newRoom: 60)
		)
		(if (& local2 $0008)
			(gEgo loop: 3 baseSetter: 0)
			(proc0_18)
			(global2 newRoom: 62)
		)
		(if (& local2 $0004)
			(gEgo loop: 0 baseSetter: 0)
			(proc0_18)
			(global2 newRoom: 64)
		)
		(if (and (& local2 $0400) (!= global105 18))
			(= global105 18)
			(gEgo setScript: moveOnTheStairs)
		)
		(super doit:)
	)
	
	(method (handleEvent pEvent)
		(return
			(cond 
				((pEvent claimed?) (return 1))
				((== (pEvent type?) evSAID)
					(cond 
						(
							(or
								(Said 'look[<around][/!*]')
								(Said 'look[<around]/room')
							)
							(proc255_0 68 0)
						)
						(
							(or
								(Said 'is<how<time')
								(Said 'is<how/time')
								(Said 'read/time')
								(Said 'read/clock')
								(Said '[!*]/time')
								(Said 'look/time')
							)
							(proc255_0
								(Format
									@global228
									68
									1
									(if (mod global160 12) (mod global160 12) else 12)
									global159
									(if (and (> global160 11) (< global160 24))
										{P.M.}
									else
										{A.M.}
									)
								)
								80
								{TAMIR TIME}
								67
								-1
								20
								33
								global23
							)
						)
						((Said 'look>')
							(cond 
								((Said '<behind/painting') (proc255_0 68 2))
								((Said '/painting') (proc255_0 68 3))
								((Said '/mirror')
									(if (gEgo inRect: 161 154 195 189)
										(gEgo loop: 3)
										(proc255_0 68 4)
									else
										(proc255_0 800 1)
									)
								)
								((Said '/chandelier') (proc255_0 68 5))
								((Said '/stair') (proc255_0 68 6))
								((Said '<in/clock') (proc255_0 68 7))
								((Said '/clock') (proc255_0 68 8))
								((Said '/door') (proc255_0 68 9))
								((Said '/wall') (proc255_0 68 10))
								((or (Said '/dirt') (Said '<down')) (proc255_0 68 11))
								((Said '/carpet') (proc255_0 68 12))
								((Said '/table') (proc255_0 68 13))
							)
						)
						((Said 'wind/clock') (proc255_0 68 14))
						((Said 'get/clock') (proc255_0 68 15))
						((Said 'open/clock') (proc255_0 68 7))
						((Said 'get/carpet') (proc255_0 68 16))
						((Said 'get/painting') (proc255_0 68 17))
					)
				)
			)
		)
	)
	
	(method (newRoom newRoomNumber)
		(if (== newRoomNumber 17)
			((ScriptID 603) keep: 0)
			(= global189 0)
		)
		(super newRoom: newRoomNumber)
	)
)

(instance mirrorTricks of Script
	(properties)
	
	(method (init param1)
		(super init: param1)
		(client view: (gEgo view?) setPri: 0 init: hide:)
	)
	
	(method (doit)
		(if (gEgo inRect: 161 154 195 191)
			(client
				show:
				loop:
				(switch (gEgo loop?)
					(0 0)
					(1 1)
					(2 3)
					(3 2)
				)
				cel: (gEgo cel?)
				posn: (gEgo x?) (- 160 (/ (- (gEgo y?) 160) 3))
				setCycle: Walk
			)
		else
			(client hide:)
		)
	)
)

(instance moveOnTheStairs of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(proc0_8)
				(gEgo setStep: 3 3)
				(if (> (gEgo y?) 100)
					(gEgo illegalBits: 0 setMotion: MoveTo 196 81 self)
				else
					(gEgo illegalBits: 0 setMotion: MoveTo 99 139 self)
				)
			)
			(1
				(proc0_7)
				(proc0_9)
				(= global189 1)
				(gEgo setScript: 0 setStep: 4 2)
				(if (< (gEgo y?) 130)
					(gEgo baseSetter: 0)
				else
					(gEgo baseSetter: (ScriptID 0 1))
				)
				(= global105 0)
			)
		)
	)
)
