;;; Sierra Script 1.0 - (do not remove this comment)
(script# 600)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Sound)
(use Game)

(public
	rg600 0
)
(synonyms
	(dwarf ass dwarf man person)
)

(instance dwarfMusic of Sound
	(properties
		number 30
		loop -1
	)
)

(instance rg600 of Rgn
	(properties)
	
	(method (init)
		(if initialized (return))
		(= keep 1)
		(super init:)
		(= global189 1)
		(dwarfMusic owner: self play:)
	)
	
	(method (dispose)
		(if (== keep 0) (= global189 0))
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp gInvSaidMe)
		(return
			(cond 
				((pEvent claimed?) (return 1))
				((== (pEvent type?) evSAID)
					(cond 
						((Said 'look>')
							(cond 
								((Said '/dwarf') (proc255_0 600 0))
								((Said '/mine[<diamond]') (proc255_0 600 1))
								((Said '/boulder[<gray]') (proc255_0 600 2))
								((Said '[<down]/dirt[<mine]') (proc255_0 600 3))
								((Said '/passageway[<mine]') (proc255_0 600 4))
								((Said '/path') (proc255_0 600 5))
								((Said '/wall') (proc255_0 600 6))
								((Said '/bucket') (proc255_0 600 7))
								((Said '/diamond') (proc255_0 600 8))
							)
						)
						((Said 'get>')
							(cond 
								((Said '/boulder') (proc255_0 600 9))
								((Said '/diamond') (proc255_0 600 10))
								((Said '/dwarf') (proc255_0 600 11))
							)
						)
						((Said 'rob/diamond') (proc255_0 600 12))
						((Said 'climb/boulder') (proc255_0 600 13))
						(
						(or (Said 'converse/dwarf') (Said 'converse[/!*]')) (proc255_0 600 14))
						((Said 'kill/dwarf') (proc255_0 600 15))
						((or (Said 'kiss/dwarf') (Said 'kiss[/!*]')) (proc255_0 600 16))
						((Said 'hit/dwarf') (proc255_0 600 17))
						((Said 'help/dwarf') (proc255_0 600 18))
						(
							(and
								(Said 'deliver,return>')
								(= gInvSaidMe (gInv saidMe:))
							)
							(if (gEgo has: (gInv indexOf: gInvSaidMe))
								(proc255_0 600 19)
							else
								(proc0_17)
							)
						)
					)
				)
			)
		)
	)
)
