;;; Sierra Script 1.0 - (do not remove this comment)
(script# 38)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Extra)
(use Cycle)
(use Game)
(use Feature)

(public
	Room38 0
)

(local
	newProp
	newProp_2
	newExtra
	newExtra_2
)
(instance Room38 of Rm
	(properties
		picture 38
	)
	
	(method (init)
		(= north 35)
		(= south 41)
		(= west 37)
		(= horizon 74)
		(= global101 0)
		(if global100 (= picture 138))
		(super init:)
		(self setRegions: 505)
		(gEgo view: 2 xStep: 3 yStep: 2 init:)
		(= newProp (Prop new:))
		(= newProp_2 (Prop new:))
		(= newExtra (Extra new:))
		(= newExtra_2 (Extra new:))
		(newProp
			view: 662
			loop: 3
			cel: 0
			posn: 199 74
			setPri: 0
			setCycle: Fwd
			ignoreActors:
			cycleSpeed: 2
			init:
		)
		(newProp_2
			view: 662
			loop: 4
			cel: 3
			posn: 303 98
			setPri: 0
			setCycle: Fwd
			ignoreActors:
			cycleSpeed: 2
			init:
		)
		(newExtra
			view: 341
			loop: 2
			posn: 243 37
			minPause: 4
			maxPause: 60
			pauseCel: 1
			minCycles: 10
			maxCycles: 40
			ignoreActors:
			cycleSpeed: 2
			init:
		)
		(newExtra_2
			view: 341
			loop: 3
			pauseCel: 1
			minPause: 4
			maxPause: 60
			minCycles: 10
			maxCycles: 50
			posn: 214 26
			ignoreActors:
			cycleSpeed: 2
			init:
		)
		(cond 
			((== gPicture 35) (gEgo x: 196 y: 78))
			((== gPicture 41) (gEgo x: 159 y: 187))
		)
	)
	
	(method (dispose)
		(DisposeScript 988)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if (== (pEvent type?) evSAID)
			(cond 
				((Said 'look>')
					(cond 
						((Said '/bush') (proc255_0 38 0))
						((Said '/beach') (proc255_0 38 1))
						((Said '/dirt') (proc255_0 38 2))
						((Said '/grass') (proc255_0 38 3))
						((Said '/flora') (proc255_0 38 4))
						((Said '/blossom') (proc255_0 38 5))
						((Said '/forest') (proc255_0 38 6))
						((Said '/garden') (proc255_0 38 7))
						((Said '/path') (proc255_0 38 8))
						((Said '/castle') (proc255_0 38 9))
						((Said '/ocean') (proc255_0 38 10))
						((Said '/bird') (proc255_0 38 11))
						((Said '/monument,dolphin') (proc255_0 38 12))
						((Said '[<around][/island,room]') (proc255_0 38 13))
					)
				)
				((Said 'converse/bird') (proc255_0 38 14))
				((Said 'capture,get/bird') (proc255_0 38 15))
				((Said 'kiss/bird') (proc255_0 38 16))
				((Said 'get/blossom') (proc255_0 38 17))
			)
		)
	)
)
